#include "AneuMeshLoader.h"
#include <fstream>
#include <iterator>
#include <vector>


//!!! Задание на защиту (не удалять!)    ==Реализовано в MeshLoader.cpp==
//!!! Выполнить на основе Ranges.
//!!! 1. Создать контейнер тетраэдральных КЭ.
//!!! 2. С помощью потокового итератора за один pipeline вывести в файл списки ID узлов первых 10 КЭ,
//!!! у которых содержится двугранный угол больше 90 градусов.


void outputResult_with_alg_and_iter(const std::vector<int>& vec) {
    std::string output_filename = "test_file.txt";
    std::ofstream file_out(output_filename, std::ios::out | std::ios::app);
    std::copy(vec.begin(), vec.end(), std::ostream_iterator<int>(file_out, " "));
}


int main() {
    MeshLoader* test = new AneuMeshLoader;
    std::string filename;
    std::cout << "Enter filename ";
    std::cin >> filename;
    test->loadMesh(filename);

    std::vector<Node> nodes = test->get_nodes();
    std::vector<FiniteElement> finite_elements = test->get_f_elems();
    std::vector<BoundaryFiniteElement> boundaries = test->Get_bf_elems();

    std::cout << "\n\nResult of printAngles function are in file \"output.txt\"\n";
    test->printAngles("output.txt");

    /*std::vector<int> f_elem_by_nodes = test->find_f_elem_by_nodes(1, 2, 3);
    outputResult_with_alg_and_iter(f_elem_by_nodes);
    std::vector<int> f_elem_by_edge = test->find_f_elem_by_edge(1, 2);
    std::set<int> nodes_by_boundary = test->get_nodes_by_boundary(1);
    std::set<int> f_elems_by_material = test->get_f_elems_by_material(1);
    std::set<int> bf_elems_by_boundary = test->get_bf_elems_by_boundary(1);

    test->insertion_in_middle();
    auto neighbor_nodes = test->get_neighbor_nodes();*/

    


    delete test;

    return 0;
}